=== debian/changelog ===
mysql-connector-c++ (1.1.12-4) unstable; urgency=medium

  [ Rene Engelhard ]
  * DebCI: allow-stderr

  [ Dmitry Smirnov ]
  * DebCI fixes and improvements.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 14 Aug 2019 18:09:09 +1000

mysql-connector-c++ (1.1.12-3) unstable; urgency=medium

  * DebCI: really disabled examples.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 10 Aug 2019 15:07:29 +1000

mysql-connector-c++ (1.1.12-2) unstable; urgency=medium

  * DebCI: do not test examples.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 09 Aug 2019 19:58:27 +1000

mysql-connector-c++ (1.1.12-1) unstable; urgency=medium

  [ Rene Engelhard ]
  * oops, fix autopkgtest: s/needs-build/build-needed/

  [ Dmitry Smirnov ]
  * New upstream release (Closes: #917083).
  * Standards-Version: 4.4.0
  * debhelper & compat to version 12
  * Install examples.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 02 Aug 2019 12:52:03 +1000
