=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpsigurlmangle=s{$}{.asc},\
dversionmangle=s{\+dfsg\d*}{},\
" https://www.mirrorservice.org/sites/ftp.mysql.com/Downloads\
/Connector-C++/mysql-connector-c\+\+-([\d\.]+)(?:\-src)?\.tar\.(?:gz|bz2|xz)
